<?php
namespace Teknisa\PLA\Modules\Rfid\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Logacessoefet extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "pla_logacessoefet";
    protected $crudService;
    protected $parameterBag;
    protected $environment;
    protected $dataSourceManager;
    protected $parameterBagColumns = array(
        "NRORG",
        "CDLEITOR",
        "CDANTENA",
        "DTREGISTRO",
        "CDETIQUETA"
    );
    
    public function __construct($crudService, $parameterBag ,$dataSourceManager, $environment ) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }

    
    // public function save(DTO\Request $request, DTO\Response $response) {
    //     $newRow = $request->getRow();
    //     $newRow['__new_code_pk'] = 'NRSEQLOG';
    //     $newRow['__using_unit'] = false;
    //     $newRow['__table_pk'] = 'NRSEQLOG';
    //     $newRow['__new_code_length'] = 10;
    //     $newRow['__cast_number'] = true;
    //     $newRow['__is_new'] = true;
    //     $this->environment->setNrOrgTrab($newRow['NRORG']);
    //     // $newRow = $this->getRowWithCDFILIAL($newRow);
    //     // var_dump($newRow);
    //     var_dump($newRow);
    //     $newRequest = new \Zeedhi\Framework\DTO\Request\Row($newRow, $request->getMethod(),$request->getRoutePath(),$request->getUserId());
    //     parent::save($newRequest, $response);
    // }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        $scriptInitTime = microtime(true);
        $rows = $request->getDataSet()->getRows();
        $this->environment->setNrOrgTrab($rows[0]['NRORG']);
        $startTime = microtime(true);
        foreach ($rows as $dataSetItem) {
            
            $dataSetItem['__new_code_pk'] = 'NRSEQLOG';
            $dataSetItem['__using_unit'] = false;
            $dataSetItem['__table_pk'] = 'NRSEQLOG';
            $dataSetItem['__new_code_length'] = 10;
            $dataSetItem['__cast_number'] = true;
            $dataSetItem['__is_new'] = true;
        }
        echo 'forEach took: '.((microtime(true) - $startTime)*1000); //performance debug info   
        
        $newDataSet = new \Zeedhi\Framework\DataSource\DataSet($request->getDataSet()->getDataSourceName(), $rows);
        $newRequest = new \Zeedhi\Framework\DTO\Request\DataSet($newDataSet, 
                            $request->getMethod(),$request->getRoutePath(),$request->getUserId());
                            
        parent::save($newRequest, $response);
        echo 'total time: '.((microtime(true) - $scriptInitTime)*1000);  //performance debug info 
    }
    
    // @deprecated
    protected function getRowWithCDFILIAL($row){
        $conditions = array(
            array(
                'columnName' => 'DTREGISTRO',
                'operator' => '=',
                'value' => $row['DTREGISTRO'],
            ),
            array(
                'columnName' => 'NRORG',
                'operator' => '=',
                'value' => $row['NRORG'],
            ),
            array(
                'columnName' => 'CDETIQUETA',
                'operator' => '=',
                'value' => $row['CDETIQUETA'],
            ),
            array(
                'columnName' => 'CDANTENA',
                'operator' => '=',
                'value' => $row['CDANTENA'],
            ),array(
                'columnName' => 'CDLEITOR',
                'operator' => '=',
                'value' => $row['CDLEITOR'],
            )
        );
        $filterCriteria = new FilterCriteria("pla_rfid_get_filial", $conditions, 1, 1);
        $filterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        $resultSet = $dataSet->getRows();
        if(count($resultSet) > 0 ){
            $row['CDFILIAL'] =  $resultSet[0]['CDFILIAL'];
            $row['CDSERVFILI'] =  $resultSet[0]['CDSERVFILI'];
        } else {
            $row['CDFILIAL'] = null;
            $row['CDSERVFILI'] = null;
        }
        return $row;
    }
    
} 